Bug 1614549

Summary: Review Request: CubicSDR - Cross-Platform Software-Defined Radio Application
Product: [Fedora] Fedora Reporter: Matt Domsch <matt>
Component: Package ReviewAssignee: Robert-André Mauchin 🐧 <zebob.m>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: djh, package-review, zebob.m
Target Milestone: ---Flags: zebob.m: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2018-08-30 04:52:56 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1614550    
Bug Blocks:    

Description Matt Domsch 2018-08-09 21:30:54 UTC
Spec URL: https://domsch.com/fedora/sdr/CubicSDR.spec
SRPM URL: https://domsch.com/fedora/sdr/CubicSDR-0.2.4-1.fc28.src.rpm
Description: Cross-Platform Software-Defined Radio Application. Provides a panadapter-style application for tuning and listening to radio stations using a software-defined radio adapter.
Fedora Account System Username: mdomsch

Comment 1 Robert-André Mauchin 🐧 2018-08-12 16:08:33 UTC
 - Why do you package a snapshot instead of the latest release?

 - If you do package a snapshot, then the Release field must contain info about it, see https://fedoraproject.org/wiki/Packaging:Versioning#Snapshots

%global commit a7e4d911e92a7063888528afe0efe321c02b9a7b
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global snapshotdate 20180807

Name:           CubicSDR
Version:        0.2.4
Release:        1.%{snapshotdate}git%{shortcommit}%{?dist}


 - rm -rf $RPM_BUILD_ROOT is not needed

 - Add: Provides: bundled(lodepng) = 20180809 too

Comment 2 Matt Domsch 2018-08-14 04:45:58 UTC
All changes made as requested in this and related packages.
$ rpmlint Cubic*
CubicSDR.x86_64: W: no-documentation
CubicSDR.x86_64: W: no-manual-page-for-binary CubicSDR
CubicSDR.x86_64: W: no-manual-page-for-binary CubicSDR.bin
4 packages and 1 specfiles checked; 0 errors, 3 warnings.

Comment 3 Robert-André Mauchin 🐧 2018-08-14 13:41:11 UTC
 - There are different licenses for the 3rd party:

*No copyright* zlib/libpng
--------------------------
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/tinyxml/tinystr.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/tinyxml/tinystr.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/tinyxml/tinyxml.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/tinyxml/tinyxml.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/tinyxml/tinyxmlparser.cpp

LGPL (v2.1 or later)
--------------------
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/hamlib/hamlib/rig.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/hamlib/hamlib/rig_dll.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/hamlib/hamlib/riglist.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/hamlib/hamlib/rotator.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/hamlib/hamlib/rotlist.h

MIT/X11 (BSD like)
------------------
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/liquid-dsp/include/liquid/liquid.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/liquid-dsp/makefile.mingw32
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/liquid-dsp/makefile.mingw64
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rs232/README
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rs232/rs232-linux.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rs232/rs232-win.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rs232/rs232.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rtaudio/RtAudio.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rtaudio/RtAudio.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/rtaudio/readme
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/src/util/DataTree.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/src/util/DataTree.h

zlib/libpng
-----------
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/lodepng/lodepng.cpp
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/lodepng/lodepng.h
CubicSDR-a7e4d911e92a7063888528afe0efe321c02b9a7b/external/tinyxml/tinyxmlerror.cpp

   Add them to the license field and add a comment explaining the license breakdown.




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "*No copyright* zlib/libpng", "LGPL (v2.1
     or later)", "Unknown or generated", "zlib/libpng". 298 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/CubicSDR/review-CubicSDR/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     CubicSDR-debuginfo , CubicSDR-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: CubicSDR-0.2.4-1.20180806gita7e4d91.fc29.x86_64.rpm
          CubicSDR-debuginfo-0.2.4-1.20180806gita7e4d91.fc29.x86_64.rpm
          CubicSDR-debugsource-0.2.4-1.20180806gita7e4d91.fc29.x86_64.rpm
          CubicSDR-0.2.4-1.20180806gita7e4d91.fc29.src.rpm
CubicSDR.x86_64: W: no-documentation
CubicSDR.x86_64: W: no-manual-page-for-binary CubicSDR
CubicSDR.x86_64: W: no-manual-page-for-binary CubicSDR.bin
4 packages and 0 specfiles checked; 0 errors, 3 warnings.

Comment 4 Matt Domsch 2018-08-15 18:53:24 UTC
Thank you. Will this suffice?

diff --git a/CubicSDR.spec b/CubicSDR.spec
index cfba303..a0e3939 100644
--- a/CubicSDR.spec
+++ b/CubicSDR.spec
@@ -6,7 +6,13 @@ Version:        0.2.4
 Release:        1.%{snapshotdate}git%{shortcommit}%{?dist}
 Summary:        Cross-Platform Software-Defined Radio Panadapter

-License:        GPLv2+
+# The primary license of CubicSDR is GPLv2+.
+# There are multiple third party libraries bundled in the source of CubicSDR.
+# external/loadpng/ and external/tinyxml/ use the zlib/libpng license
+# external/rs232/, external/liquid-dsp/, src/util/DataTree* use the MIT/X11 (BSD like) license
+# Note: external/hamlib/ and external/rtaudio/ are provided by the source, but at
+#  build and run time we use system-provided copies of these libraries
+License:        GPLv2+ and MIT and zlib
 URL:            https://cubicsdr.com
 Source0:        https://github.com/cjcliffe/%{name}/archive/%{commit}/%{name}-%{shortcommit}.tar.gz
 Source1:        CubicSDR

Comment 5 Robert-André Mauchin 🐧 2018-08-15 18:57:25 UTC
Yes perfect.

Package approved.

Comment 6 Gwyn Ciesla 2018-08-15 19:22:20 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/CubicSDR

Comment 7 Fedora Update System 2018-08-16 13:44:07 UTC
CubicSDR-0.2.4-1.20180806gita7e4d91.fc28 liquid-dsp-1.3.1-3.20180806git9658d81.fc28 soapy-rtlsdr-0.2.5-1.fc28 SoapySDR-0.6.1-1.20180806gite694813.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-b2b91c05b7

Comment 8 Fedora Update System 2018-08-17 15:35:13 UTC
CubicSDR-0.2.4-1.20180806gita7e4d91.fc28, SoapySDR-0.6.1-1.20180806gite694813.fc28, liquid-dsp-1.3.1-3.20180806git9658d81.fc28, soapy-rtlsdr-0.2.5-1.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-b2b91c05b7

Comment 9 Fedora Update System 2018-08-30 04:52:56 UTC
CubicSDR-0.2.4-1.20180806gita7e4d91.fc28, SoapySDR-0.6.1-1.20180806gite694813.fc28, liquid-dsp-1.3.1-3.20180806git9658d81.fc28, soapy-rtlsdr-0.2.5-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.